/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: OSGIConsoleModelLocator.as 20454 2010-10-12 15:52:44Z lglglglg $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.osgiconsole.model
{
	import com.adobe.cairngorm.model.ModelLocator;

	import mx.collections.ArrayCollection;

	import org.ow2.jonas.admin.osgiconsole.business.BundleActionDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.BundleInfoDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.BundleInfoUpdateDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.BundleInstallDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.ErrorUpdateDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.OBRRepoActionDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.OBRRepoDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.ServiceInfoDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.ServiceSelectedDelegate;
	import org.ow2.jonas.admin.osgiconsole.business.ShellDelegate;
	import org.ow2.jonas.admin.osgiconsole.view.ShellView;

	[Bindable]
	public class OSGIConsoleModelLocator implements ModelLocator
	{
		private static var unique : OSGIConsoleModelLocator;
		public var bundleInfoDelegate : BundleInfoDelegate = null;
		public var bundleInfoUpdateDelegate : BundleInfoUpdateDelegate = null;
		public var bundleInstallDelegate : BundleInstallDelegate = null;
		public var bundleActionDelegate : BundleActionDelegate = null;
		public var shellDelegate : ShellDelegate = null;
		public var serviceInfoDelegate : ServiceInfoDelegate =  null;
		public var serviceSelectedDelegate : ServiceSelectedDelegate = null;
		public var obrRepoDelegate : OBRRepoDelegate = null;
		public var obrRepoActionDelegate : OBRRepoActionDelegate = null;
		public var errorUpdateDelegate : ErrorUpdateDelegate = null;

		[ArrayElementType(BundleInfoVO)]
		public var bundles : ArrayCollection = null;
		[ArrayElementType(ServiceInfoVO)]
		public var services : ArrayCollection = null;
		public var shelltext : String = null;
		public var serviceInfo:String=null;
		public var obrInfo:String=null;
		public var obrRepo:XML=null;
		public var shellView:ShellView=null;

		public var componentID : String = UIDUtil.createUID();

		public function OSGIConsoleModelLocator()
		{
			if (unique != null) {
            	throw new Error("Error: Singletons can only be" + "instantiated via getInstance() method!");
        	}
        	OSGIConsoleModelLocator.unique = this;

        	bundleInfoDelegate = new BundleInfoDelegate();
        	bundleInfoUpdateDelegate = new BundleInfoUpdateDelegate();
        	bundleInstallDelegate = new BundleInstallDelegate();
        	bundleActionDelegate = new BundleActionDelegate();
        	shellDelegate = new ShellDelegate();
        	serviceInfoDelegate = new ServiceInfoDelegate();
        	serviceSelectedDelegate = new ServiceSelectedDelegate();
        	obrRepoDelegate = new OBRRepoDelegate();
        	obrRepoActionDelegate = new OBRRepoActionDelegate();
        	errorUpdateDelegate = new ErrorUpdateDelegate();

        	bundles = new ArrayCollection();
        	services = new ArrayCollection();
        	shelltext = "";
        	serviceInfo="";
        	obrInfo="";
  		}
  		public static function getInstance() : OSGIConsoleModelLocator{
  			if(unique == null){
  				unique = new OSGIConsoleModelLocator();
  			}
  			return unique;
  		}
	}
}